#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,float *B8,int N){
for(int i=0;i<N;i++){
A0[i] = A2[i];
B0[i] = B8[i]*B7[i]/B8[i];
B1[i] = B7[i]+B7[i]-B8[i]-B7[i];
B2[i] = B7[i]-B8[i];
B3[i] = B8[i]-B8[i]*B7[i];
B4[i] = B7[i];
B5[i] = B7[i]+B7[i];
B6[i] = B7[i]-B8[i]/B7[i];
}
}

int main(int argc,char **argv) {
int size=394460;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
float *B8;
B8 = (float *)malloc(floatBytes);
for(int i=0;i<394460;i++){
A0[i] = 83+i+1;
A1[i] = 95+i+1;
A2[i] = 10+i+1;
A3[i] = 64+i+1;
B0[i] = 96.6766789314*i+1;
B1[i] = 10.9206283198*i+1;
B2[i] = 91.3121224782*i+1;
B3[i] = 60.8813496866*i+1;
B4[i] = 1.61362335304*i+1;
B5[i] = 31.4714747035*i+1;
B6[i] = 51.0584500611*i+1;
B7[i] = 35.8858218025+i+1;
B8[i] = 82.9322140851*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,B0,B1,B2,B3,B4,B5,B6,B7,B8,394460);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
free(B8);
printf("\n");return 0; }